package de.tudarmstadt.maki.simonstrator.api.component.uavsupport.strategy;

import de.tudarmstadt.maki.simonstrator.api.Message;
import de.tudarmstadt.maki.simonstrator.api.component.sensor.location.Location;
import de.tudarmstadt.maki.simonstrator.api.component.uavsupport.strategy.callbacks.ShutdownStrategyCallback;

/**
 * Interface for a strategy that is running on a UAV component.
 * 
 * @author Julian Zobel
 *
 */
public interface StrategyUAV {

	public void startStrategy();

	public void stopStrategy();

	/**
	 * Reiceiving control messages (UAV <-> UAV and UAV <-> Control Center)
	 * 
	 * @param message
	 */
	public void messageArrived(Message message);

	/**
	 * Called, when receiving a message from the GROUND DTN
	 * 
	 * @param message
	 *            the unaltered DTN message received by the UAV
	 */
	public void dtnMessageArrived(Message message);

	public void initialize();

	public void locationChanged(Location location);

	public void componentLanded(ShutdownStrategyCallback cb);

}
